/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"

#if ENABLE(MEDIA_SESSION)

#include "JSMediaMetadataInit.h"

#include "JSDOMConvertSequences.h"
#include "JSDOMConvertStrings.h"
#include "JSDOMGlobalObject.h"
#include "JSMediaImage.h"
#include "ScriptExecutionContext.h"
#include <JavaScriptCore/JSArray.h>
#include <JavaScriptCore/JSCInlines.h>
#include <JavaScriptCore/ObjectConstructor.h>


namespace WebCore {
using namespace JSC;

#if ENABLE(MEDIA_SESSION)

template<> MediaMetadataInit convertDictionary<MediaMetadataInit>(JSGlobalObject& lexicalGlobalObject, JSValue value)
{
    VM& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    bool isNullOrUndefined = value.isUndefinedOrNull();
    auto* object = isNullOrUndefined ? nullptr : value.getObject();
    if (UNLIKELY(!isNullOrUndefined && !object)) {
        throwTypeError(&lexicalGlobalObject, throwScope);
        return { };
    }
    MediaMetadataInit result;
    JSValue albumValue;
    if (isNullOrUndefined)
        albumValue = jsUndefined();
    else {
        albumValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "album"_s));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!albumValue.isUndefined()) {
        result.album = convert<IDLDOMString>(lexicalGlobalObject, albumValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else
        result.album = emptyString();
    JSValue artistValue;
    if (isNullOrUndefined)
        artistValue = jsUndefined();
    else {
        artistValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "artist"_s));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!artistValue.isUndefined()) {
        result.artist = convert<IDLDOMString>(lexicalGlobalObject, artistValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else
        result.artist = emptyString();
    JSValue artworkValue;
    if (isNullOrUndefined)
        artworkValue = jsUndefined();
    else {
        artworkValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "artwork"_s));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!artworkValue.isUndefined()) {
        result.artwork = convert<IDLSequence<IDLDictionary<MediaImage>>>(lexicalGlobalObject, artworkValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else
        result.artwork = Converter<IDLSequence<IDLDictionary<MediaImage>>>::ReturnType{ };
    JSValue titleValue;
    if (isNullOrUndefined)
        titleValue = jsUndefined();
    else {
        titleValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "title"_s));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!titleValue.isUndefined()) {
        result.title = convert<IDLDOMString>(lexicalGlobalObject, titleValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else
        result.title = emptyString();
#if ENABLE(MEDIA_SESSION_PLAYLIST)
    if (jsCast<JSDOMGlobalObject*>(&lexicalGlobalObject)->scriptExecutionContext()->settingsValues().mediaSessionPlaylistEnabled) {
        JSValue trackIdentifierValue;
        if (isNullOrUndefined)
            trackIdentifierValue = jsUndefined();
        else {
            trackIdentifierValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "trackIdentifier"_s));
            RETURN_IF_EXCEPTION(throwScope, { });
        }
        if (!trackIdentifierValue.isUndefined()) {
            result.trackIdentifier = convert<IDLDOMString>(lexicalGlobalObject, trackIdentifierValue);
            RETURN_IF_EXCEPTION(throwScope, { });
        } else
            result.trackIdentifier = emptyString();
    }
#endif
    return result;
}

JSC::JSObject* convertDictionaryToJS(JSC::JSGlobalObject& lexicalGlobalObject, JSDOMGlobalObject& globalObject, const MediaMetadataInit& dictionary)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);

    auto result = constructEmptyObject(&lexicalGlobalObject, globalObject.objectPrototype());

    auto albumValue = toJS<IDLDOMString>(lexicalGlobalObject, throwScope, dictionary.album);
    RETURN_IF_EXCEPTION(throwScope, { });
    result->putDirect(vm, JSC::Identifier::fromString(vm, "album"_s), albumValue);
    auto artistValue = toJS<IDLDOMString>(lexicalGlobalObject, throwScope, dictionary.artist);
    RETURN_IF_EXCEPTION(throwScope, { });
    result->putDirect(vm, JSC::Identifier::fromString(vm, "artist"_s), artistValue);
    auto artworkValue = toJS<IDLSequence<IDLDictionary<MediaImage>>>(lexicalGlobalObject, globalObject, throwScope, dictionary.artwork);
    RETURN_IF_EXCEPTION(throwScope, { });
    result->putDirect(vm, JSC::Identifier::fromString(vm, "artwork"_s), artworkValue);
    auto titleValue = toJS<IDLDOMString>(lexicalGlobalObject, throwScope, dictionary.title);
    RETURN_IF_EXCEPTION(throwScope, { });
    result->putDirect(vm, JSC::Identifier::fromString(vm, "title"_s), titleValue);
#if ENABLE(MEDIA_SESSION_PLAYLIST)
    if (jsCast<JSDOMGlobalObject*>(&globalObject)->scriptExecutionContext()->settingsValues().mediaSessionPlaylistEnabled) {
        auto trackIdentifierValue = toJS<IDLDOMString>(lexicalGlobalObject, throwScope, dictionary.trackIdentifier);
        RETURN_IF_EXCEPTION(throwScope, { });
        result->putDirect(vm, JSC::Identifier::fromString(vm, "trackIdentifier"_s), trackIdentifierValue);
    }
#endif
    return result;
}

#endif

} // namespace WebCore

#endif // ENABLE(MEDIA_SESSION)
